#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # 2A.ml - Machine Learning et Marketting
# 
# Prédire la souscription d'un contrat sur le jeu de données [Bank Marketing Data Set ](https://archive.ics.uci.edu/ml/datasets/Bank+Marketing).

# In[1]:


get_ipython().run_line_magic('matplotlib', 'inline')


# In[2]:


import matplotlib.pyplot as plt


# In[3]:


from jyquickhelper import add_notebook_menu
add_notebook_menu()


# ### Données

# Le jeu de données [Bank Marketing Data Set ](https://archive.ics.uci.edu/ml/datasets/Bank+Marketing) contient des données destinées à évaluer le fait qu'une personne souscrive un contrat. La base de données contient 45.000 observations avec 17 attributs et une variable binaire qui représente le résultat à prédire. Tout d'abord, on récupère la base de données.

# In[4]:


url = "https://archive.ics.uci.edu/ml/machine-learning-databases/00222/"
file = "bank.zip"
import pyensae.datasource
data = pyensae.datasource.download_data(file, website=url)


# In[5]:


with open("bank.csv","r") as fo :
    n = 0
    for row in fo :
        print(row.strip("\r\n "))
        n += 1
        if n > 5 : break


# In[6]:


import pandas
df = pandas.read_csv("bank.csv",sep=";")
df.tail()


# ### Exercice 1 : prédire y en fonction des attributs
# 
# On utilisera pour cela un [GradientBoostingClassifier](http://scikit-learn.org/stable/modules/generated/sklearn.ensemble.GradientBoostingClassifier.html) après avoir sciender la base en base d'apprentissage et tests. Quelques liens :
# 
# * [train_test_split](http://scikit-learn.org/stable/modules/generated/sklearn.model_selection.train_test_split.html)
# * [DictVectorizer](http://scikit-learn.org/stable/modules/generated/sklearn.feature_extraction.DictVectorizer.html)
# * [Using DictVectorizer with sklearn DecisionTreeClassifier](http://stackoverflow.com/questions/15181311/using-dictvectorizer-with-sklearn-decisiontreeclassifier)
# * [iterrows](http://pandas.pydata.org/pandas-docs/stable/generated/pandas.DataFrame.iterrows.html)

# In[7]:





# ### Exercice 2 : tracer la courbe ROC
# 
# La plupart des classifieur produisent deux chiffres en sorties : la classe et un score. Le score est souvent une probabilité et il traduit la qualité du classifieur. On s'en sert alors pour accepter ou rejeter la prédiction [Sensitivity and specificity](http://en.wikipedia.org/wiki/Sensitivity_and_specificity). La dénomination ``vrai positif``, ``faux positif``, ... est assez trompeuse. Il vaut mieux retenir les définitions de [précision, rappel](http://fr.wikipedia.org/wiki/Pr%C3%A9cision_et_rappel).
# 
# Comme le classifieur retourne un score de confiance, on décide de valider ou de rejeter sa réponse si le score est supérieur ou inférieur à ce seuil :
# 
# * si score >= seuil, on valide la réponse, qui est soit bonne (TP : True Positive), soit fausse (FP : False Positive)
# * si score < seuil, on rejete la réponse qui est soit bonne (FN : False Negative) soit fausse (True Negative)
# 
# La présicion est définie comme étant le nombre de réponses justes sur le nombre de réponses validées :
# 
# $$precision = \frac{TP}{TP + FP}$$
# 
# Le rappel est défini comme étant le nombre de réponses justes sur le nombre total de réponses justes :
# 
# 
# $$rappel = \frac{TP}{TP + FN}$$
# 
# Dans notre cas, on définit une réponse juste comme étant le fait qu'on prédit la bonne classe. Quelques liens :
# 
# * [Receiver Operating Characteristic (ROC)](http://scikit-learn.org/stable/auto_examples/plot_roc.html)
# 
# Et il faudra tracer sur le même dessin la courbe ROC de :
# 
# * l'ensemble de la base de test
# * deux échantillons aléatoires de la base de test
# 
# Les courbes des deux échantillons aléatoires devraient illustrer la stabilité de la courbe ROC. Il est même possible de calculer un intervalle de confiance en utilisant un [bootstrap](http://fr.wikipedia.org/wiki/Bootstrap_%28statistiques%29).
# 
# Quelques liens sur matplotlib :
# 
# * [Our Favorite Recipes](http://matplotlib.org/users/recipes.html)
# * [How to make several plots on a single page using matplotlib?](http://stackoverflow.com/questions/1358977/how-to-make-several-plots-on-a-single-page-using-matplotlib)

# In[8]:





# In[9]: